VERSION 5.00
Object = "{6B7E6392-850A-101B-AFC0-4210102A8DA7}#1.3#0"; "COMCTL32.OCX"
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   4590
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   4920
   LinkTopic       =   "Form1"
   ScaleHeight     =   4590
   ScaleWidth      =   4920
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmdDelete 
      Caption         =   "Delete Book"
      Height          =   495
      Left            =   3360
      TabIndex        =   5
      Top             =   3240
      Width           =   1215
   End
   Begin VB.CommandButton cmdEdit 
      Caption         =   "Edit Book"
      Height          =   495
      Left            =   3360
      TabIndex        =   4
      Top             =   2640
      Width           =   1215
   End
   Begin VB.CommandButton cmdNew 
      Caption         =   "New Book"
      Height          =   495
      Left            =   3360
      TabIndex        =   3
      Top             =   2040
      Width           =   1215
   End
   Begin VB.CommandButton cmdSave 
      Caption         =   "Save File"
      Height          =   495
      Left            =   3360
      TabIndex        =   2
      Top             =   720
      Width           =   1215
   End
   Begin VB.CommandButton cmdLoad 
      Caption         =   "Load File"
      Height          =   495
      Left            =   3360
      TabIndex        =   1
      Top             =   120
      Width           =   1215
   End
   Begin ComctlLib.TreeView TreeView1 
      Height          =   4215
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   3135
      _ExtentX        =   5530
      _ExtentY        =   7435
      _Version        =   327682
      Style           =   7
      Appearance      =   1
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private CatalogDoc As MSXML2.DOMDocument40  'XML document object
Public EditCancelled As Boolean             'was form2's cancel button clicked?

Private Sub cmdLoad_Click()
'Not yet implemented, check future articles for an updated version.

End Sub

Private Sub cmdNew_Click()
    Dim NewBookNode As MSXML2.IXMLDOMNode           'New root node for the new book item
    Dim DocFrag As MSXML2.IXMLDOMDocumentFragment   'Document fragment used to build new book item
    Dim valResult As MSXML2.IXMLDOMParseError
    
    EditCancelled = True
       
    'create the new book element
    Set NewBookNode = CatalogDoc.createElement("book")
    CatalogDoc.documentElement.appendChild NewBookNode
    'Build the child nodes of the book node and hand
    'it off to the edit form
    Set Form2.BookNode = BuildBookNodes(NewBookNode)
    Set Form2.CatalogDoc = CatalogDoc
    Form2.Show 1, Me
    
    If EditCancelled Then
        CatalogDoc.documentElement.removeChild NewBookNode
    Else
        'rebuild the UI
        BuildTree
    End If
    
End Sub

Private Sub cmdEdit_Click()
'Not yet implemented, check future articles for an updated version.
    
End Sub

Private Sub cmdSave_Click()
'Not yet implemented, check future articles for an updated version.

End Sub

Private Sub Form_Load()
    SetupCatalogDoc
End Sub

Private Sub BuildTree()
    
    'Update the book list shown in the Treeview to match any changes
    Dim BookNode As MSXML2.IXMLDOMNode      'the "book" node
    Dim ChildNode As MSXML2.IXMLDOMNode     'reused node for author, title, etc. elements
    Dim TextNode As MSXML2.IXMLDOMNode      'resued node to get at text data
    
    Dim i As Integer
    Dim TreeNode As Node                    'Node in the Treeview control
    
    'Reset the Treeview
    Me.TreeView1.Nodes.Clear
    
    'for each book element in catalog...
    For Each BookNode In CatalogDoc.documentElement.childNodes
        
        'first get the id attribute
        Set TextNode = BookNode.Attributes.getNamedItem("id")
        Set TreeNode = Me.TreeView1.Nodes.Add(, , TextNode.nodeValue, "Book " & TextNode.nodeValue)
        
        'Preserve the indes for this book's Treeview node so we can add the other
        'document nodes as children in the Treeview
        i = TreeNode.Index
        
        'for each element in the book node...
        For Each ChildNode In BookNode.childNodes
            'get the data from the text node
            Set TextNode = ChildNode.firstChild
            Set TreeNode = Me.TreeView1.Nodes.Add(i, tvwChild, , TextNode.nodeValue)
        Next
    Next
           
End Sub

Private Function BuildBookNodes(RootNode As IXMLDOMNode) As IXMLDOMNode
    'Build the document structure needed to add a new book to the catalog
    
    Dim TitleNode As MSXML2.IXMLDOMNode     'Book title
    Dim AuthorNode As MSXML2.IXMLDOMNode    'Book Author
    Dim PriceNode As MSXML2.IXMLDOMNode     'Book Price
    Dim GenreNode As MSXML2.IXMLDOMNode     'Book Genre
    Dim DescNode As MSXML2.IXMLDOMNode      'Book Description
    Dim PubDateNode As MSXML2.IXMLDOMNode   'Book publish date
    Dim ID As MSXML2.IXMLDOMAttribute       'ID attribute for the book
    Dim CatalogNode As MSXML2.IXMLDOMNode   'The document's root catalog element
    
    'Create the ID attribute node for the new book
    Set ID = CatalogDoc.createAttribute("id")
    'Calculate the value of the new ID attribute
    Set CatalogNode = CatalogDoc.documentElement
    ID.Value = "bk" & CatalogNode.childNodes.length
    
    'Create all the new data nodes
    Set TitleNode = CatalogDoc.createElement("title")
    Set AuthorNode = CatalogDoc.createElement("author")
    Set PriceNode = CatalogDoc.createElement("price")
    Set GenreNode = CatalogDoc.createElement("genre")
    Set DescNode = CatalogDoc.createElement("description")
    Set PubDateNode = CatalogDoc.createElement("publish_date")
    
    'add space for text under all the new nodes
    TitleNode.appendChild CatalogDoc.createTextNode("")
    AuthorNode.appendChild CatalogDoc.createTextNode("")
    PriceNode.appendChild CatalogDoc.createTextNode("")
    GenreNode.appendChild CatalogDoc.createTextNode("")
    DescNode.appendChild CatalogDoc.createTextNode("")
    PubDateNode.appendChild CatalogDoc.createTextNode("")
    
    'Add the new nodes to the root "book" node
    'Note that the append order is important
    RootNode.Attributes.setNamedItem ID
    RootNode.appendChild AuthorNode
    RootNode.appendChild TitleNode
    RootNode.appendChild GenreNode
    RootNode.appendChild PriceNode
    RootNode.appendChild PubDateNode
    RootNode.appendChild DescNode
    
    'Return the new root "book" node
    Set BuildBookNodes = RootNode
    
End Function
Private Sub SetupCatalogDoc()
    Dim Version As MSXML2.IXMLDOMProcessingInstruction  '<?xml version="1.0"?>
        
    'Create a new document object
    Set Me.CatalogDoc = New MSXML2.DOMDocument40
    CatalogDoc.preserveWhiteSpace = False
    CatalogDoc.async = False
    'tell the parser to automatically load externally defined DTD's or XSD's
    CatalogDoc.resolveExternals = True
    
    Set Version = CatalogDoc.createProcessingInstruction("xml", "version=" & Chr(34) & "1.0" & Chr(34))
        
    'create the root catalog element
    'and append it and the XML version to the document
    CatalogDoc.appendChild Version
    CatalogDoc.appendChild CatalogDoc.createElement("catalog")
    
End Sub
